# __gnu_debug::basic_string< _CharT, _Traits, _Allocator > Class Template Reference

Inheritance diagram for __gnu_debug::basic_string< _CharT, _Traits, _Allocator >:

List of all members.

## Detailed Description

### template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
class __gnu_debug::basic_string< _CharT, _Traits, _Allocator >

Definition at line 46 of file debug/string.

## Public Types

- typedef _Allocator allocator_type
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::const_iterator,
  basic_string > const_iterator
- typedef _Base::const_pointer const_pointer
- typedef _Base::const_reference const_reference
- typedef std::reverse_iterator<
  const_iterator > const_reverse_iterator
- typedef _Base::difference_type difference_type
- typedef __gnu_debug::_Safe_iterator<
  typename _Base::iterator,
  basic_string > iterator
- typedef _Base::pointer pointer
- typedef _Base::reference reference
- typedef std::reverse_iterator<
  iterator > reverse_iterator
- typedef _Base::size_type size_type
- typedef _Traits traits_type
- typedef _Traits::char_type value_type

## Public Member Functions

- const _Base & _M_base () const
- _Base & _M_base ()
- void _M_invalidate_all () const
- template<typename _Predicate> void _M_invalidate_if (_Predicate __pred)
- template<typename _Iterator> void _M_transfer_iter (const _Safe_iterator< _Iterator, _Sequence > &__x)
- basic_string & append (size_type __n, _CharT__c)
- basic_string & append (const _CharT *__s, size_type __n)
- basic_string & append (const basic_string &__str, size_type __pos, size_type __n)
- basic_string & append (const basic_string &__str)
- template<typename _InputIterator> basic_string & append (_InputIterator __first, _InputIterator __last)
- basic_string & append (size_type __n, _CharT __c)
- basic_string & append (const _CharT *__s)
- basic_string & append (const _CharT *__s, size_type __n)
- basic_string & append (const basic_string &__str, size_type __pos, size_type __n)
- basic_string & append (const basic_string &__str)
- basic_string & assign (size_type __n, _CharT__c)
- basic_string & assign (const _CharT *__s, size_type __n)
- basic_string & assign (const basic_string &__str, size_type __pos, size_type __n)
- basic_string & assign (const basic_string &__str)
- template<typename _InputIterator> basic_string & assign (_InputIterator __first, _InputIterator __last)
- basic_string & assign (size_type __n, _CharT __c)
- basic_string & assign (const _CharT *__s)
- basic_string & assign (const _CharT *__s, size_type __n)
- basic_string & assign (const basic_string &__str, size_type __pos, size_type __n)
- basic_string & assign (const basic_string &__x)
- reference at (size_type __n)
- const_reference at (size_type __n) const
- template<typename _InputIterator> basic_string (_InputIterator __begin, _InputIterator __end, const _Allocator &__a=_Allocator())
- basic_string (size_type __n, _CharT __c, const _Allocator &__a=_Allocator())
- basic_string (const _CharT *__s, const _Allocator &__a=_Allocator())
- basic_string (const _CharT *__s, size_type __n, const _Allocator &__a=_Allocator())
- basic_string (const basic_string &__str, size_type __pos, size_type __n=_Base::npos, const _Allocator &__a=_Allocator())
- basic_string (const basic_string &__str)
- basic_string (const _Base &__base)
- basic_string (const _Allocator &__a=_Allocator())
- const_iterator begin () const
- iterator begin ()
- const _CharT * c_str () const
- size_type capacity () const
- void clear ()
- int compare (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2) const
- int compare (size_type __pos, size_type __n1, const _CharT *__s) const
- int compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2) const
- int compare (size_type __pos, size_type __n, const basic_string &__str) const
- int compare (const basic_string &__str) const
- int compare (size_type __pos1, size_type __n1, const _CharT *__s, size_type __n2) const
- int compare (size_type __pos1, size_type __n1, const _CharT *__s) const
- int compare (const _CharT *__s) const
- int compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2) const
- int compare (size_type __pos1, size_type __n1, const basic_string &__str) const
- int compare (const basic_string &__str) const
- size_type copy (_CharT *__s, size_type __n, size_type __pos=0) const
- size_type copy (_CharT *__s, size_type __n, size_type __pos=0) const
- const _CharT * data () const
- bool empty () const
- const_iterator end () const
- iterator end ()
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __position)
- basic_string & erase (size_type __pos=0, size_type __n=npos)
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __position)
- basic_string & erase (size_type __pos=0, size_type __n=_Base::npos)
- size_type find (_CharT__c, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos=0) const
- size_type find (const basic_string &__str, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find (_CharT __c, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos=0) const
- size_type find (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find (const basic_string &__str, size_type __pos=0) const
- size_type find_first_not_of (_CharT__c, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_not_of (const basic_string &__str, size_type __pos=0) const
- size_type find_first_not_of (_CharT __c, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_not_of (const basic_string &__str, size_type __pos=0) const
- size_type find_first_of (_CharT__c, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_of (const basic_string &__str, size_type __pos=0) const
- size_type find_first_of (_CharT __c, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos=0) const
- size_type find_first_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_first_of (const basic_string &__str, size_type __pos=0) const
- size_type find_last_not_of (_CharT__c, size_type __pos=npos) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos=npos) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_not_of (const basic_string &__str, size_type __pos=npos) const
- size_type find_last_not_of (_CharT __c, size_type __pos=_Base::npos) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos=_Base::npos) const
- size_type find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_not_of (const basic_string &__str, size_type __pos=_Base::npos) const
- size_type find_last_of (_CharT__c, size_type __pos=npos) const
- size_type find_last_of (const _CharT *__s, size_type __pos=npos) const
- size_type find_last_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_of (const basic_string &__str, size_type __pos=npos) const
- size_type find_last_of (_CharT __c, size_type __pos=_Base::npos) const
- size_type find_last_of (const _CharT *__s, size_type __pos=_Base::npos) const
- size_type find_last_of (const _CharT *__s, size_type __pos, size_type __n) const
- size_type find_last_of (const basic_string &__str, size_type __pos=_Base::npos) const
- allocator_type get_allocator () const
- iterator insert (iterator __p, _CharT__c)
- basic_string & insert (size_type __pos, size_type __n, _CharT__c)
- basic_string & insert (size_type __pos, const _CharT *__s)
- basic_string & insert (size_type __pos, const _CharT *__s, size_type __n)
- basic_string & insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
- basic_string & insert (size_type __pos1, const basic_string &__str)
- void insert (iterator __p, _InputIterator __beg, _InputIterator __end)
- void insert (iterator __p, size_type __n, _CharT__c)
- template<typename _InputIterator> void insert (iterator __p, _InputIterator __first, _InputIterator __last)
- void insert (iterator __p, size_type __n, _CharT __c)
- iterator insert (iterator __p, _CharT __c)
- basic_string & insert (size_type __pos, size_type __n, _CharT __c)
- basic_string & insert (size_type __pos, const _CharT *__s)
- basic_string & insert (size_type __pos, const _CharT *__s, size_type __n)
- basic_string & insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
- basic_string & insert (size_type __pos1, const basic_string &__str)
- size_type length () const
- size_type max_size () const
- basic_string & operator+= (const basic_string &__str)
- basic_string & operator+= (_CharT __c)
- basic_string & operator+= (const _CharT *__s)
- basic_string & operator+= (const basic_string &__str)
- basic_string & operator= (_CharT __c)
- basic_string & operator= (const _CharT *__s)
- basic_string & operator= (const basic_string &__str)
- reference operator[] (size_type __pos)
- const_reference operator[] (size_type __pos) const
- reference operator[] (size_type __pos)
- const_reference operator[] (size_type __pos) const
- void push_back (_CharT __c)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- basic_string & replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
- basic_string & replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
- basic_string & replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
- basic_string & replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
- basic_string & replace (iterator __i1, iterator __i2, size_type __n, _CharT__c)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__s)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
- basic_string & replace (iterator __i1, iterator __i2, const basic_string &__str)
- basic_string & replace (size_type __pos, size_type __n1, size_type __n2, _CharT__c)
- basic_string & replace (size_type __pos, size_type __n1, const _CharT *__s)
- basic_string & replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
- basic_string & replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
- basic_string & replace (size_type __pos, size_type __n, const basic_string &__str)
- template<typename _InputIterator> basic_string & replace (iterator __i1, iterator __i2, _InputIterator __j1, _InputIterator __j2)
- basic_string & replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__s)
- basic_string & replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
- basic_string & replace (iterator __i1, iterator __i2, const basic_string &__str)
- basic_string & replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
- basic_string & replace (size_type __pos, size_type __n1, const _CharT *__s)
- basic_string & replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
- basic_string & replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
- basic_string & replace (size_type __pos1, size_type __n1, const basic_string &__str)
- void reserve (size_type __res_arg=0)
- void resize (size_type __n)
- void resize (size_type __n, _CharT__c)
- void resize (size_type __n)
- void resize (size_type __n, _CharT __c)
- size_type rfind (_CharT__c, size_type __pos=npos) const
- size_type rfind (const _CharT *__s, size_type __pos=npos) const
- size_type rfind (const _CharT *__s, size_type __pos, size_type __n) const
- size_type rfind (const basic_string &__str, size_type __pos=npos) const
- size_type rfind (_CharT __c, size_type __pos=_Base::npos) const
- size_type rfind (const _CharT *__s, size_type __pos=_Base::npos) const
- size_type rfind (const _CharT *__s, size_type __pos, size_type __n) const
- size_type rfind (const basic_string &__str, size_type __pos=_Base::npos) const
- size_type size () const
- basic_string substr (size_type __pos=0, size_type __n=npos) const
- basic_string substr (size_type __pos=0, size_type __n=_Base::npos) const
- void swap (basic_string &__s)
- void swap (basic_string< _CharT, _Traits, _Allocator > &__x)
- ~basic_string ()

## Public Attributes

- _Safe_iterator_base * _M_const_iterators
- _Safe_iterator_base * _M_iterators
- unsigned int _M_version

## Static Public Attributes

- static const size_type npos

## Protected Member Functions

- void _M_detach_all ()
- void _M_detach_singular ()
- __gnu_cxx::__mutex & _M_get_mutex ()
- void _M_revalidate_singular ()
- void _M_swap (_Safe_sequence_base &__x)

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const _Allocator & | __a = `_Allocator()` | ) | `[inline, explicit]`

Construct an empty string using allocator a.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 77 of file debug/string.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | const _CharT * | __s,
|  | const _Allocator & | __a = `_Allocator()` |
| ) |  |  | `[inline]`

Construct string as copy of a C string.

Parameters:

  | s | Source C string.
  | a | Allocator to use (default is default allocator).

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 103 of file debug/string.

References __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::basic_string | ( | _InputIterator | __begin,
|  | _InputIterator | __end,
|  | const _Allocator & | __a = `_Allocator()` |
| ) |  |  | `[inline]`

Construct string as copy of a range.

Parameters:

  | beg | Start of range.
  | end | End of range.
  | a | Allocator to use (default is default allocator).

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 113 of file debug/string.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

__gnu_debug::basic_string< _CharT, _Traits, _Allocator >::~basic_string | ( |  | ) | `[inline]`

Destroy the string instance.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 118 of file debug/string.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | `[protected, inherited]`

Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | `[protected, inherited]`

Detach all singular iterators.

Postcondition:
  for all iterators i attached to this sequence, i->_M_version == _M_version.

Referenced by std::__debug::deque< _Tp, _Allocator >::erase(), and std::__debug::list< _Tp, _Allocator >::resize().

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | `[protected, inherited]`

For use in _Safe_sequence.

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const`[inline, inherited]`

Invalidates all iterators.

Definition at line 220 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append(), std::__debug::vector< _Tp, _Allocator >::assign(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign(), std::__debug::deque< _Tp, _Allocator >::assign(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::c_str(), std::__debug::vector< _Tp, _Allocator >::clear(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::clear(), std::__debug::deque< _Tp, _Allocator >::clear(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::data(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::erase(), std::__debug::deque< _Tp, _Allocator >::erase(), __gnu_debug::getline(), std::__debug::vector< _Tp, _Allocator >::insert(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert(), std::__debug::deque< _Tp, _Allocator >::insert(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+=(), std::__debug::vector< _Tp, _Allocator >::operator=(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator=(), std::__debug::deque< _Tp, _Allocator >::operator=(), __gnu_debug::operator>>(), std::__debug::vector< _Tp, _Allocator >::push_back(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::push_back(), std::__debug::deque< _Tp, _Allocator >::push_back(), std::__debug::deque< _Tp, _Allocator >::push_front(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::replace(), std::__debug::vector< _Tp, _Allocator >::reserve(), std::__debug::vector< _Tp, _Allocator >::resize(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::resize(), std::__debug::deque< _Tp, _Allocator >::resize(), and __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::swap().

template<typename _Sequence>
template<typename _Predicate>

void __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if | ( | _Predicate | __pred | ) | `[inherited]`

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `pred(x)` returns `true`. The user of this routine should be careful not to make copies of the iterators passed to `pred`, as the copies may interfere with the invalidation.

Definition at line 126 of file safe_sequence.h.

References __gnu_debug::_Safe_sequence_base::_M_const_iterators, and __gnu_debug::_Safe_sequence_base::_M_iterators.

Referenced by std::__debug::vector< _Tp, _Allocator >::erase(), std::__debug::vector< _Tp, _Allocator >::insert(), std::__debug::vector< _Tp, _Allocator >::resize(), and std::__debug::deque< _Tp, _Allocator >::resize().

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | `[protected, inherited]`

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reasion, such as an exception, need to become valid again).

Referenced by std::__debug::deque< _Tp, _Allocator >::erase(), and std::__debug::list< _Tp, _Allocator >::resize().

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) | `[protected, inherited]`

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

Referenced by std::__debug::vector< _Tp, _Allocator >::swap(), __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::swap(), std::__debug::set< _Key, _Compare, _Allocator >::swap(), std::__debug::multiset< _Key, _Compare, _Allocator >::swap(), std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >::swap(), std::__debug::map< _Key, _Tp, _Compare, _Allocator >::swap(), std::__debug::list< _Tp, _Allocator >::swap(), __gnu_cxx::__debug::hash_set< _Value, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_multiset< _Value, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_multimap< _Value, _Tp, _HashFcn, _EqualKey, _Alloc >::swap(), __gnu_cxx::__debug::hash_map< _Value, _Tp, _HashFcn, _EqualKey, _Alloc >::swap(), and std::__debug::deque< _Tp, _Allocator >::swap().

template<typename _Sequence>
template<typename _Iterator>

void __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter | ( | const _Safe_iterator< _Iterator, _Sequence > & | __x | ) | `[inherited]`

Transfers all iterators that reference this memory location to this sequence from whatever sequence they are attached to.

Definition at line 159 of file safe_sequence.h.

References __gnu_debug::_Safe_sequence_base::_M_const_iterators, __gnu_debug::_Safe_sequence_base::_M_iterators, __gnu_debug::_Safe_iterator_base::_M_sequence, and __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::base().

Referenced by std::__debug::list< _Tp, _Allocator >::splice().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::append | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inherited]`

Append multiple characters.

Parameters:

  | n | The number of characters to append.
  | c | The character to use.

Returns:
  Reference to this string.

Appends n copies of c to this string.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::append | ( | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inherited]`

Append a C substring.

Parameters:

  | s | The C string to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::append | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | `[inherited]`

Append a substring.

Parameters:

  | str | The string to append.
  | pos | Index of the first character of str to append.
  | n | The number of characters to append.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function appends n characters from str starting at pos to this string. If n is is larger than the number of available characters in str, the remainder of str is appended.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::append | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) | `[inherited]`

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Append a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Appends characters in the range [first,last) to this string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 306 of file debug/string.

References __glibcxx_check_valid_range, __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::append().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::append | ( | const _CharT * | __s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 288 of file debug/string.

References __glibcxx_check_string, __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::append().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::assign | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline, inherited]`

Set value to multiple characters.

Parameters:

  | n | Length of the resulting string.
  | c | The character to use.

Returns:
  Reference to this string.

This function sets the value of this string to n copies of character c.

Definition at line 933 of file basic_string.h.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::assign | ( | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inherited]`

Set value to a C substring.

Parameters:

  | s | The C string to use.
  | n | Number of characters to use.

Returns:
  Reference to this string.

This function sets the value of this string to the first n characters of s. If n is is larger than the number of available characters in s, the remainder of s is used.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::assign | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | `[inline, inherited]`

Set value to a substring of a string.

Parameters:

  | str | The string to use.
  | pos | Index of the first character of str.
  | n | Number of characters to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of str consisting of n characters at pos. If n is is larger than the number of available characters in str, the remainder of str is used.

Definition at line 889 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::_M_check(), std::basic_string< _CharT, _Traits, _Alloc >::_M_data(), and std::basic_string< _CharT, _Traits, _Alloc >::_M_limit().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::assign | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) | `[inherited]`

Set value to contents of another string.

Parameters:

  | str | Source string to use.

Returns:
  Reference to this string.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
template<typename _InputIterator>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | _InputIterator | __first,
|  | _InputIterator | __last |
| ) |  |  | `[inline]`

Set value to a range of characters.

Parameters:

  | first | Iterator referencing the first character to append.
  | last | Iterator marking the end of the range.

Returns:
  Reference to this string.

Sets value of string to characters in the range [first,last).

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 367 of file debug/string.

References __glibcxx_check_valid_range, __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::assign().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::assign | ( | const _CharT * | __s | ) | `[inline]`

Set value to contents of a C string.

Parameters:

  | s | The C string to use.

Returns:
  Reference to this string.

This function sets the value of this string to the value of s. The data is copied, so there is no dependence on s once the function returns.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 349 of file debug/string.

References __glibcxx_check_string, __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::assign().

reference std::basic_string< _CharT , _Traits , _Allocator >::at | ( | size_type | __n | ) | `[inline, inherited]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read/write reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 747 of file basic_string.h.

References __N.

const_reference std::basic_string< _CharT , _Traits , _Allocator >::at | ( | size_type | __n | ) | const`[inline, inherited]`

Provides access to the data contained in the string.

Parameters:

  | n | The index of the character to access.

Returns:
  Read-only (const) reference to the character.

Exceptions:

  | std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 728 of file basic_string.h.

References __N.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::begin | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points to the first character in the string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 151 of file debug/string.

References std::basic_string< _CharT, _Traits, _Allocator >::begin().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::begin | ( |  | ) | `[inline]`

Returns a read/write iterator that points to the first character in the string. Unshares the string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 147 of file debug/string.

References std::basic_string< _CharT, _Traits, _Allocator >::begin().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rend().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const _CharT* __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::c_str | ( |  | ) | const`[inline]`

Return const pointer to null-terminated contents.

This is a handle to internal data. Do not modify or dire things may happen.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 585 of file debug/string.

References __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::c_str().

size_type std::basic_string< _CharT , _Traits , _Allocator >::capacity | ( |  | ) | const`[inline, inherited]`

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 641 of file basic_string.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::clear | ( |  | ) | `[inline]`

Erases the string, making it empty.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 198 of file debug/string.

References __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::clear().

int std::basic_string< _CharT , _Traits , _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 |
| ) |  |  | const`[inherited]`

Compare substring against a character array.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | character array to compare against.
  | n2 | Number of characters of s.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form a string from the first n2 characters of s. Returns an integer < 0 if this substring is ordered before the string from s, 0 if their values are equivalent, or > 0 if this substring is ordered after the string from s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and n2. The function then compares the two strings by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

NB: s must have at least n2 characters, '' has no special meaning.

int std::basic_string< _CharT , _Traits , _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s |
| ) |  |  | const`[inherited]`

Compare substring to a C string.

Parameters:

  | pos | Index of first character of substring.
  | n1 | Number of characters in substring.
  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos. Returns an integer < 0 if the substring is ordered before s, 0 if their values are equivalent, or > 0 if the substring is ordered after s. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and the length of a string constructed from s. The function then compares the two string by calling traits::compare(substring.data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

int std::basic_string< _CharT , _Traits , _Allocator >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 |
| ) |  |  | const`[inherited]`

Compare substring to a substring.

Parameters:

  | pos1 | Index of first character of substring.
  | n1 | Number of characters in substring.
  | str | String to compare against.
  | pos2 | Index of first character of substring of str.
  | n2 | Number of characters in substring of str.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n1 characters starting at pos1. Form the substring of str from the n2 characters starting at pos2. Returns an integer < 0 if this substring is ordered before the substring of str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

int std::basic_string< _CharT , _Traits , _Allocator >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str |
| ) |  |  | const`[inherited]`

Compare substring to a string.

Parameters:

  | pos | Index of first character of substring.
  | n | Number of characters in substring.
  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Form the substring of this string from the n characters starting at pos. Returns an integer < 0 if the substring is ordered before str, 0 if their values are equivalent, or > 0 if the substring is ordered after str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

int std::basic_string< _CharT , _Traits , _Allocator >::compare | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) | const`[inline, inherited]`

Compare to a string.

Parameters:

  | str | String to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before str, 0 if their values are equivalent, or > 0 if this string is ordered after str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 1929 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::data(), std::min(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::compare().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

int __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::compare | ( | const _CharT * | __s | ) | const`[inline]`

Compare to a C string.

Parameters:

  | s | C string to compare against.

Returns:
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before s, 0 if their values are equivalent, or > 0 if this string is ordered after s. Determines the effective length rlen of the strings to compare as the smallest of size() and the length of a string constructed from s. The function then compares the two strings by calling traits::compare(data(),s,rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 755 of file debug/string.

References __glibcxx_check_string, and std::basic_string< _CharT, _Traits, _Allocator >::compare().

size_type std::basic_string< _CharT , _Traits , _Allocator >::copy | ( | _CharT * | __s,
|  | size_type | __n,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inherited]`

Copy substring into C string.

Parameters:

  | s | C string to copy value into.
  | n | Number of characters to copy.
  | pos | Index of first character to copy.

Returns:
  Number of characters actually copied

Exceptions:

  | std::out_of_range | If pos > size().

Copies up to n characters starting at pos into the C string s. If pos is greater than size(), out_of_range is thrown.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const _CharT* __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::data | ( |  | ) | const`[inline]`

Return const pointer to contents.

This is a handle to internal data. Do not modify or dire things may happen.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 593 of file debug/string.

References __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::data().

bool std::basic_string< _CharT , _Traits , _Allocator >::empty | ( |  | ) | const`[inline, inherited]`

Returns true if the string is empty. Equivalent to *this == "".

Definition at line 675 of file basic_string.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::end | ( |  | ) | const`[inline]`

Returns a read-only (constant) iterator that points one past the last character in the string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 159 of file debug/string.

References std::basic_string< _CharT, _Traits, _Allocator >::end().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::end | ( |  | ) | `[inline]`

Returns a read/write iterator that points one past the last character in the string. Unshares the string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 155 of file debug/string.

References std::basic_string< _CharT, _Traits, _Allocator >::end().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rbegin().

iterator std::basic_string< _CharT , _Traits , _Allocator >::erase | ( | iterator | __first,
|  | iterator | __last |
| ) |  |  | `[inline, inherited]`

Remove a range of characters.

Parameters:

  | first | Iterator referencing the first character to remove.
  | last | Iterator referencing the end of the range.

Returns:
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1156 of file basic_string.h.

References _GLIBCXX_DEBUG_PEDASSERT.

iterator std::basic_string< _CharT , _Traits , _Allocator >::erase | ( | iterator | __position | ) | `[inline, inherited]`

Remove one character.

Parameters:

  | position | Iterator referencing the character to remove.

Returns:
  iterator referencing same location after removal.

Removes the character at position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1136 of file basic_string.h.

References _GLIBCXX_DEBUG_PEDASSERT.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::erase | ( | size_type | __pos = `0`,
|  | size_type | __n = `npos` |
| ) |  |  | `[inline, inherited]`

Remove characters.

Parameters:

  | pos | Index of first character to remove (default 0).
  | n | Number of characters to remove (default remainder).

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.

Removes n characters from this string starting at pos. The length of the string is reduced by n. If there are < n characters to remove, the remainder of the string is truncated. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1120 of file basic_string.h.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::erase().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inherited]`

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for c within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline, inherited]`

Find position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1581 of file basic_string.h.

References __glibcxx_requires_string, and std::find().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline, inherited]`

Find position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1567 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::data(), std::find(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const`[inherited]`

Find position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of first occurrence.

Starting from pos, searches forward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_not_of | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inherited]`

Find position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline, inherited]`

Find position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1820 of file basic_string.h.

References __glibcxx_requires_string.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const`[inherited]`

Find position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search from.
  | n | Number of characters from s to consider.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline, inherited]`

Find position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1791 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::data(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_first_not_of().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_of | ( | _CharT | __c,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline, inherited]`

Find position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for the character c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to find(c, pos).

Definition at line 1716 of file basic_string.h.

References std::find().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline, inherited]`

Find position of a character of C string.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1697 of file basic_string.h.

References __glibcxx_requires_string, and std::find_first_of().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const`[inherited]`

Find position of a character of C substring.

Parameters:

  | s | String containing characters to locate.
  | pos | Index of character to search from.
  | n | Number of characters from s to search for.

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_first_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `0` |
| ) |  |  | const`[inline, inherited]`

Find position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search from (default 0).

Returns:
  Index of first occurrence.

Starting from pos, searches forward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1669 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::data(), std::find_first_of(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_not_of | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inherited]`

Find last position of a different character.

Parameters:

  | c | Character to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character other than c within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline, inherited]`

Find last position of a character not in C string.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1879 of file basic_string.h.

References __glibcxx_requires_string.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_not_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const`[inherited]`

Find last position of a character not in C substring.

Parameters:

  | s | C string containing characters to avoid.
  | pos | Index of character to search back from.
  | n | Number of characters from s to consider.

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_not_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline, inherited]`

Find last position of a character not in string.

Parameters:

  | str | String containing characters to avoid.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for a character not contained in str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1850 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::data(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_last_not_of().

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_of | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline, inherited]`

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

Note: equivalent to rfind(c, pos).

Definition at line 1777 of file basic_string.h.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline, inherited]`

Find last position of a character of C string.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1758 of file basic_string.h.

References __glibcxx_requires_string.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_of | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const`[inherited]`

Find last position of a character of C substring.

Parameters:

  | s | C string containing characters to locate.
  | pos | Index of character to search back from.
  | n | Number of characters from s to search for.

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the first n characters of s within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::find_last_of | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline, inherited]`

Find last position of a character of string.

Parameters:

  | str | String containing characters to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for one of the characters of str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 1730 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::data(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::find_last_of().

allocator_type std::basic_string< _CharT , _Traits , _Allocator >::get_allocator | ( |  | ) | const`[inline, inherited]`

Return copy of allocator used to construct this string.

Definition at line 1539 of file basic_string.h.

iterator std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | iterator | __p,
|  | _CharT | __c |
| ) |  |  | `[inline, inherited]`

Insert one character.

Parameters:

  | p | Iterator referencing position in string to insert at.
  | c | The character to insert.

Returns:
  Iterator referencing newly inserted char.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts character c at position referenced by p. If adding character causes the length to exceed max_size(), length_error is thrown. If p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1096 of file basic_string.h.

References _GLIBCXX_DEBUG_PEDASSERT.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | size_type | __pos,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline, inherited]`

Insert multiple characters.

Parameters:

  | pos | Index in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts n copies of character c starting at index pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos > length(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1079 of file basic_string.h.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | size_type | __pos,
|  | const _CharT * | __s |
| ) |  |  | `[inline, inherited]`

Insert a C string.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1056 of file basic_string.h.

References __glibcxx_requires_string.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | size_type | __pos,
|  | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inherited]`

Insert a C substring.

Parameters:

  | pos | Iterator referencing location in string to insert at.
  | s | The C string to insert.
  | n | The number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos is beyond the end of this string.

Inserts the first n characters of s starting at pos. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos is beyond end(), out_of_range is thrown. The value of the string doesn't change if an error is thrown.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n |
| ) |  |  | `[inline, inherited]`

Insert a substring.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.
  | pos2 | Start of characters in str to insert.
  | n | Number of characters to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.
  | std::out_of_range | If pos1 > size() or pos2 > str.size().

Starting at pos1, insert n character of str beginning with pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If pos1 is beyond the end of this string or pos2 is beyond the end of str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1015 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::_M_check(), std::basic_string< _CharT, _Traits, _Alloc >::_M_data(), and std::basic_string< _CharT, _Traits, _Alloc >::_M_limit().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str |
| ) |  |  | `[inline, inherited]`

Insert value of a string.

Parameters:

  | pos1 | Iterator referencing location in string to insert at.
  | str | The string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts value of str starting at pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 993 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::size().

void std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end |
| ) |  |  | `[inline, inherited]`

Insert a range of characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | beg | Start of range.
  | end | End of range.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [beg,end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 978 of file basic_string.h.

References std::replace().

void std::basic_string< _CharT , _Traits , _Allocator >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline, inherited]`

Insert multiple characters.

Parameters:

  | p | Iterator referencing location in string to insert at.
  | n | Number of characters to insert
  | c | The character to insert.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Inserts n copies of character c starting at the position referenced by iterator p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 962 of file basic_string.h.

References std::replace().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::insert().

size_type std::basic_string< _CharT , _Traits , _Allocator >::length | ( |  | ) | const`[inline, inherited]`

null-termination.

Definition at line 601 of file basic_string.h.

size_type std::basic_string< _CharT , _Traits , _Allocator >::max_size | ( |  | ) | const`[inline, inherited]`

Returns the size() of the largest possible string.

Definition at line 606 of file basic_string.h.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::operator+= | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str | ) | `[inline, inherited]`

Append a string to this string.

Parameters:

  | str | The string to append.

Returns:
  Reference to this string.

Definition at line 762 of file basic_string.h.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+= | ( | _CharT | __c | ) | `[inline]`

Append a character.

Parameters:

  | c | The character to append.

Returns:
  Reference to this string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 255 of file debug/string.

References __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::_M_base(), and __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator+= | ( | const _CharT * | __s | ) | `[inline]`

Append a C string.

Parameters:

  | s | The C string to append.

Returns:
  Reference to this string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 246 of file debug/string.

References __glibcxx_check_string, __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::_M_base(), and __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator= | ( | _CharT | __c | ) | `[inline]`

Set value to string of length 1.

Parameters:

  | c | Source character.

Assigning to a character makes this string length 1 and (*this)[0] == c.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 138 of file debug/string.

References __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

basic_string& __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator= | ( | const _CharT * | __s | ) | `[inline]`

Copy contents of s into this string.

Parameters:

  | s | Source null-terminated string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 129 of file debug/string.

References __glibcxx_check_string, and __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

reference std::basic_string< _CharT , _Traits , _Allocator >::operator[] | ( | size_type | __pos | ) | `[inline, inherited]`

Subscript access to the data contained in the string.

Parameters:

  | pos | The index of the character to access.

Returns:
  Read/write reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().) Unshares the string.

Definition at line 707 of file basic_string.h.

References _GLIBCXX_DEBUG_ASSERT, and _GLIBCXX_DEBUG_PEDASSERT.

const_reference std::basic_string< _CharT , _Traits , _Allocator >::operator[] | ( | size_type | __pos | ) | const`[inline, inherited]`

Subscript access to the data contained in the string.

Parameters:

  | pos | The index of the character to access.

Returns:
  Read-only (constant) reference to the character.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 690 of file basic_string.h.

References _GLIBCXX_DEBUG_ASSERT.

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::push_back | ( | _CharT | __c | ) | `[inline]`

Append a single character.

Parameters:

  | c | Character to append.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 317 of file debug/string.

References __gnu_debug::_Safe_sequence_base::_M_invalidate_all(), and std::basic_string< _CharT, _Traits, _Allocator >::push_back().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rbegin | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to the last character in the string. Iteration is done in reverse element order.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 167 of file debug/string.

References __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::end().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rbegin | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to the last character in the string. Iteration is done in reverse element order. Unshares the string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 163 of file debug/string.

References __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::end().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rend | ( |  | ) | const`[inline]`

Returns a read-only (constant) reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 175 of file debug/string.

References __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::begin().

template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reverse_iterator __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rend | ( |  | ) | `[inline]`

Returns a read/write reverse iterator that points to one before the first character in the string. Iteration is done in reverse element order. Unshares the string.

Reimplemented from std::basic_string< _CharT, _Traits, _Allocator >.

Definition at line 171 of file debug/string.

References __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::begin().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2 |
| ) |  |  | `[inline, inherited]`

Replace range of characters with range.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | k1 | Iterator referencing start of range to insert.
  | k2 | Iterator referencing end of range to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, characters in the range [k1,k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1372 of file basic_string.h.

References __glibcxx_requires_valid_range, and _GLIBCXX_DEBUG_PEDASSERT.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inline, inherited]`

Replace range of characters with multiple characters.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | n | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, n copies of c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1349 of file basic_string.h.

References _GLIBCXX_DEBUG_PEDASSERT.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s |
| ) |  |  | `[inline, inherited]`

Replace range of characters with C string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1328 of file basic_string.h.

References __glibcxx_requires_string, and std::replace().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n |
| ) |  |  | `[inline, inherited]`

Replace range of characters with C substring.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | s | C string value to insert.
  | n | Number of characters from s to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the first n characters of s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1307 of file basic_string.h.

References _GLIBCXX_DEBUG_PEDASSERT, and std::replace().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str |
| ) |  |  | `[inline, inherited]`

Replace range of characters with string.

Parameters:

  | i1 | Iterator referencing start of range to replace.
  | i2 | Iterator referencing end of range to replace.
  | str | String value to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [i1,i2). In place, the value of str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1289 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::_M_data(), std::replace(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | size_type | __n2,
|  | _CharT | __c |
| ) |  |  | `[inline, inherited]`

Replace characters with multiple characters.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | n2 | Number of characters to insert.
  | c | Character to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, n2 copies of c are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1271 of file basic_string.h.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s |
| ) |  |  | `[inline, inherited]`

Replace characters with value of a C string.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | s | C string to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the first n characters of s are inserted. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1248 of file basic_string.h.

References __glibcxx_requires_string, and std::replace().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n1,
|  | const _CharT * | __s,
|  | size_type | __n2 |
| ) |  |  | `[inherited]`

Replace characters with value of a C substring.

Parameters:

  | pos | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | s | C string to insert.
  | n2 | Number of characters from s to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos + n1) from this string. In place, the first n2 characters of s are inserted, or all of s if n2 is too large. If pos is beyond end of string, out_of_range is thrown. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 |
| ) |  |  | `[inline, inherited]`

Replace characters with value from another string.

Parameters:

  | pos1 | Index of first character to replace.
  | n1 | Number of characters to be replaced.
  | str | String to insert.
  | pos2 | Index of first character of str to use.
  | n2 | Number of characters from str to use.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos1 > size() or pos2 > str.size().
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos1,pos1 + n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1205 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::_M_check(), std::basic_string< _CharT, _Traits, _Alloc >::_M_data(), std::basic_string< _CharT, _Traits, _Alloc >::_M_limit(), and std::replace().

basic_string& std::basic_string< _CharT , _Traits , _Allocator >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, _Traits, _Allocator > & | __str |
| ) |  |  | `[inline, inherited]`

Replace characters with value from another string.

Parameters:

  | pos | Index of first character to replace.
  | n | Number of characters to be replaced.
  | str | String to insert.

Returns:
  Reference to this string.

Exceptions:

  | std::out_of_range | If pos is beyond the end of this string.
  | std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [pos,pos+n) from this string. In place, the value of str is inserted. If pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1183 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::_M_data(), std::replace(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

void std::basic_string< _CharT , _Traits , _Allocator >::reserve | ( | size_type | __res_arg = `0` | ) | `[inherited]`

Attempt to preallocate enough memory for specified number of characters.

Parameters:

  | res_arg | Number of characters required.

Exceptions:

  | std::length_error | If res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

void std::basic_string< _CharT , _Traits , _Allocator >::resize | ( | size_type | __n | ) | `[inline, inherited]`

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.

This function will resize the string to the specified length. If the new size is smaller than the string's current size the string is truncated, otherwise the string is extended and new characters are default-constructed. For basic types such as char, this means setting them to 0.

Definition at line 633 of file basic_string.h.

void std::basic_string< _CharT , _Traits , _Allocator >::resize | ( | size_type | __n,
|  | _CharT | __c |
| ) |  |  | `[inherited]`

Resizes the string to the specified number of characters.

Parameters:

  | n | Number of characters the string should contain.
  | c | Character to fill any new elements.

This function will resize the string to the specified number of characters. If the number is smaller than the string's current size the string is truncated, otherwise the string is extended and new elements are set to c.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::resize().

size_type std::basic_string< _CharT , _Traits , _Allocator >::rfind | ( | _CharT | __c,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inherited]`

Find last position of a character.

Parameters:

  | c | Character to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of last occurrence.

Starting from pos, searches backward for c within this string. If found, returns the index where it was found. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline, inherited]`

Find last position of a C string.

Parameters:

  | s | C string to locate.
  | pos | Index of character to start search at (default end).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the value of s within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1639 of file basic_string.h.

References __glibcxx_requires_string.

size_type std::basic_string< _CharT , _Traits , _Allocator >::rfind | ( | const _CharT * | __s,
|  | size_type | __pos,
|  | size_type | __n |
| ) |  |  | const`[inherited]`

Find last position of a C substring.

Parameters:

  | s | C string to locate.
  | pos | Index of character to search back from.
  | n | Number of characters from s to search for.

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for the first n characters in s within this string. If found, returns the index where it begins. If not found, returns npos.

size_type std::basic_string< _CharT , _Traits , _Allocator >::rfind | ( | const basic_string< _CharT, _Traits, _Allocator > & | __str,
|  | size_type | __pos = `npos` |
| ) |  |  | const`[inline, inherited]`

Find last position of a string.

Parameters:

  | str | String to locate.
  | pos | Index of character to search back from (default end).

Returns:
  Index of start of last occurrence.

Starting from pos, searches backward for value of str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 1611 of file basic_string.h.

References std::basic_string< _CharT, _Traits, _Alloc >::data(), and std::basic_string< _CharT, _Traits, _Alloc >::size().

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::rfind().

size_type std::basic_string< _CharT , _Traits , _Allocator >::size | ( |  | ) | const`[inline, inherited]`

null-termination.

Definition at line 595 of file basic_string.h.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::operator[]().

basic_string std::basic_string< _CharT , _Traits , _Allocator >::substr | ( | size_type | __pos = `0`,
|  | size_type | __n = `npos` |
| ) |  |  | const`[inline, inherited]`

Get a substring.

Parameters:

  | pos | Index of first character (default 0).
  | n | Number of characters in substring (default remainder).

Returns:
  The new string.

Exceptions:

  | std::out_of_range | If pos > size().

Construct and return a new string using the n characters starting at pos. If the string is too short, use the remainder of the characters. If pos is beyond the end of the string, out_of_range is thrown.

Definition at line 1911 of file basic_string.h.

Referenced by __gnu_debug::basic_string< _CharT, _Traits, _Allocator >::substr().

void std::basic_string< _CharT , _Traits , _Allocator >::swap | ( | basic_string< _CharT, _Traits, _Allocator > & | __s | ) | `[inherited]`

Swap contents with another string.

Parameters:

  | s | String to swap with.

Exchanges the contents of this string with that of s in constant time.

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators `[inherited]`

The list of constant iterators that reference this container.

Definition at line 171 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators `[inherited]`

The list of mutable iterators that reference this container.

Definition at line 168 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version `[mutable, inherited]`

The container version number. This number may never be 0.

Definition at line 174 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

const size_type std::basic_string< _CharT , _Traits , _Allocator >::npos `[static, inherited]`

Value returned by various member functions when they fail.

Definition at line 272 of file basic_string.h.

The documentation for this class was generated from the following file:

- debug/string